<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
        <el-select v-model="projectUid" placeholder="请选择项目" style="width: 150px" clearable>
          <el-option
            v-for="item in projectOptions"
            :key="item.uid"
            :label="item.name"
            :value="item.uid"
          ></el-option>
        </el-select>
        <el-select v-model="roleUid" placeholder="请选择角色" style="width: 150px" clearable>
          <el-option
            v-for="item in roleOptions"
            :key="item.uid"
            :label="item.roleName"
            :value="item.uid"
          ></el-option>
        </el-select>
      <el-input
        clearable
        class="filter-item"
        style="width: 200px;"
        v-model="keyword"
        placeholder="请输入账号、名称、手机号"
      ></el-input>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind" v-permission="'/admin/getList'">查找</el-button>
      <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit" v-permission="'/admin/add'">添加</el-button>
    </div>

    <el-table :data="tableData" style="width: 100%">
      <!--<el-table-column type="selection"></el-table-column>-->

      <el-table-column label="ID" width="60" align="center">
        <template slot-scope="scope">
          <span>{{scope.row.uid}}</span>
        </template>
      </el-table-column>

      <!--<el-table-column label="头像" width="120" align="center">
        <template slot-scope="scope">
          <img
            v-if="scope.row.photoList"
            :src="scope.row.photoList[0]"
            style="width: 100px;height: 100px;"
          >
        </template>
      </el-table-column>-->

      <el-table-column label="账号" width="150" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.userName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="姓名" width="150" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.nickName }}</span>
        </template>
      </el-table-column>

      <el-table-column label="角色" width="150" align="center">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.role" type="danger">{{scope.row.role.roleName}}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="所属项目" width="150" align="center">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.project" type="danger">{{scope.row.project.name}}</el-tag>
          <el-tag v-else type="danger">全部</el-tag>
        </template>
      </el-table-column>

      <el-table-column label="注册时间" width="150" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>

      <!--<el-table-column label="性别" width="60" align="center">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.gender==1" type="success">男</el-tag>
          <el-tag v-if="scope.row.gender==2" type="danger">女</el-tag>
        </template>
      </el-table-column>

      <el-table-column label="登录次数" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.loginCount }}</span>
        </template>
      </el-table-column>

      <el-table-column label="已用空间" width="100" align="center">
        <template slot-scope="scope">
          <el-tag type="warning">{{ calculateFileSize(scope.row.storageSize)}}</el-tag>
        </template>
      </el-table-column>

      <el-table-column label="网盘大小" width="100" align="center">
        <template slot-scope="scope">
          <el-tag type="warning">{{ calculateFileSize(scope.row.maxStorageSize * 1024 * 1024)}}</el-tag>
        </template>
      </el-table-column>

      <el-table-column label="登录IP" width="160" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.lastLoginIp }}</span>
        </template>
      </el-table-column>-->
<!--
      <el-table-column label="最后登录时间" width="160" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.lastLoginTime }}</span>
        </template>
      </el-table-column>-->

      <el-table-column label="状态" width="100" align="center">
        <template slot-scope="scope">
          <template v-if="scope.row.status == 1">
            <span>正常登录</span>
          </template>
          <template v-if="scope.row.status == 0">
            <span>禁止登录</span>
          </template>
        </template>
      </el-table-column>

      <el-table-column label="操作" fixed="right" min-width="250" >
        <template slot-scope="scope">
          <!--<el-button @click="handRest(scope.row)" type="warning" size="small" v-permission="'/admin/restPwd'">重置密码</el-button>-->
          <el-button @click="handleEdit(scope.row)" type="primary" size="small" v-permission="'/admin/edit'">管理</el-button>
         <!-- <el-button @click="handleDelete(scope.row)" type="danger" size="small" v-permission="'/admin/delete'">删除</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" width="500px" :before-close="handleClose" center>
        <el-form :model="form" :rules="rules" ref="form" label-width="150px">
          <!--<el-form-item label="用户头像" :label-width="formLabelWidth">
            <div class="imgBody" v-if="form.photoList">
              <i class="el-icon-error inputClass" v-show="icon" @click="deletePhoto()" @mouseover="icon = true"></i>
              <img @mouseover="icon = true" @mouseout="icon = false" v-bind:src="form.photoList[0]" />
            </div>

            <div v-else class="uploadImgBody" @click="checkPhoto">
              <i class="el-icon-plus avatar-uploader-icon"></i>
            </div>
          </el-form-item>-->
          <el-form-item label="uid" :label-width="formLabelWidth"  v-if="false">
            <el-input v-model="form.uid" placeholder="uid" style="width: 70%"/>
          </el-form-item>
          <el-form-item label="账号" :label-width="formLabelWidth" prop="userName">
            <span v-model="form.userName" v-if="form.uid">{{form.userName}}</span>
            <el-input v-model="form.userName" placeholder="请输入账号" style="width: 70%" v-else/>
          </el-form-item>
          <el-row type="flex" class="row-bg" v-if="form.uid"  style="width: 100%">
            <el-col>
              <el-form-item label="密码" :label-width="formLabelWidth">
                <span v-if="form.uid" class="avatar-uploader">{{this.passWordShow}}</span>
              </el-form-item>
            </el-col>
            <el-form-item >
              <el-button type="primary" v-if="form.uid" @click="handlePassWordEdit()" >修改</el-button>
            </el-form-item>
          </el-row>
          <el-form-item label="密码" :label-width="formLabelWidth" prop="passWord" v-else>
            <el-input v-model="form.passWord" style="width: 70%" placeholder="请输入密码"/>
          </el-form-item>
          <!--<el-row type="flex" class="row-bg">
            <el-col :span="12">
              <el-form-item label="密码" :label-width="formLabelWidth" prop="passWord" >
                <span v-if="form.uid" class="avatar-uploader" style="width: 50%">{{this.passWordShow}}</span>
                <el-input v-model="form.passWord" placeholder="请输入密码" style="width: 200%" v-else/>
              </el-form-item>
            </el-col>
            <el-form-item >
              <el-button type="primary" v-if="form.uid" @click="handlePassWordEdit()" >修改</el-button>
            </el-form-item>
          </el-row>-->
          <el-form-item label="名称" :label-width="formLabelWidth" prop="nickName">
            <span v-model="form.nickName" v-if="form.uid">{{form.nickName}}</span>
            <el-input v-model="form.nickName" placeholder="请输入名称" style="width: 70%" v-else/>
          </el-form-item>
          <el-form-item label="角色" :label-width="formLabelWidth" prop="roleUid">
            <el-select v-model="form.roleUid" placeholder="请选择角色" style="width: 70%">
              <el-option
                v-for="item in roleOptions"
                :key="item.uid"
                :label="item.roleName"
                :value="item.uid"
              ></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="项目" :label-width="formLabelWidth" v-if="this.form.roleUid ==2" >
            <el-select v-model="form.projectUid" placeholder="请选择项目"  style="width:  70%">
              <el-option
                v-for="item in projectOptions"
                :key="item.uid"
                :label="item.name"
                :value="item.uid"
              ></el-option>
            </el-select>
          </el-form-item>
            <el-form-item label="项目" :label-width="formLabelWidth" v-else prop="projectUid" >
            <el-select v-model="form.projectUid" placeholder="请选择项目"  style="width:  70%">
              <el-option
                v-for="item in projectOptions"
                :key="item.uid"
                :label="item.name"
                :value="item.uid"
              ></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="登录状态" :label-width="formLabelWidth" prop="status">
            <input type="radio" v-model="form.status" value="0" />&nbsp; 禁用 &nbsp;
            <input type="radio" v-model="form.status" value="1" />&nbsp; 正常 &nbsp;
          </el-form-item>
        </el-form>
      <span slot="footer" class="dialog-footer">
          <el-button type="primary" @click="submitForm">提交</el-button>
          <el-button @click="dialogFormVisible = false">关闭</el-button>
      </span>
    </el-dialog>

    <!--修改密码-->
    <el-dialog :visible.sync="passwordVisible" style="width: 1100px" center>
      <el-form :model="passwordForm" :rules="editPasswordRules" ref="form" label-width="150px">
        <!--<el-form-item label="uid" :label-width="formLabelWidth" prop="uid">
          <span>{{passwordForm.uid}}</span>
        </el-form-item>-->
        <el-form-item label="密码" :label-width="formLabelWidth" prop="passWord">
          <el-input v-model="passwordForm.passWord" placeholder="请输入密码" style="width: 280px"/>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitEditPassword">提交</el-button>
        <el-button @click="passwordVisible = false">关闭</el-button>
    </span>
    </el-dialog>

    <avatar-cropper
      v-show="imagecropperShow"
      :key="imagecropperKey"
      :width="300"
      :height="300"
      :url="url"
      lang-type="zh"
      @close="close"
      @crop-upload-success="cropSuccess"
    />

  </div>
</template>

<script>
import {
  getAdminList,
  addAdmin,
  editAdmin,
  deleteAdmin,
  restPwdAdmin,
  registerAdmin
} from "@/api/admin";

import { getRoleList } from "@/api/role";
import { getProjectList } from "@/api/project";
import {getListByDictType} from "@/api/sysDictData"
import AvatarCropper from '@/components/AvatarCropper'

import { formatData } from "@/utils/webUtils";
export default {
  data() {
    return {
      // 图片上传路径
      url: process.env.PICTURE_API + "/file/cropperPicture",
      tableData: [],
      roleOptions: [], //角色候选框
      loading: false, //搜索框加载状态
      roleData: [], //角色列表
      roleValue: [], //选择的角色列表
      projectOptions: [], //角色候选框
      projectData: [], //角色列表
      projectValue: [], //选择的角色列表
      passWordShow:"******",
      keyword: "",
      roleUid: "",
      projectUid: "",
      currentPage: 1,
      pageSize: 10,
      total: 0, //总数量
      title: "增加用户",
      dialogFormVisible: false, //控制弹出框
      passwordVisible: false,
      formLabelWidth: "120px",
      isEditForm: false,
      form: {},
      passwordForm: {},
      imagecropperKey: 0,
      imagecropperShow: false, //控制图片选择器的显示
      photoList: [],
      icon: false, //控制删除图标的显示
      genderDictList: [], //字典列表
      rules: {
        userName: [
          /*{required: false, pattern: /0?(13|14|15|17|18)[0-9]{9}/, message: '请输入正确的手机号码'}*/
          {required: true, message: '账号不能为空', trigger: 'blur'},
          {min: 1, max: 32, message: '长度在1到32个字符'},
        ],
        nickName: [
          {required: true, message: '名称不能为空', trigger: 'blur'},
          {min: 1, max: 32, message: '长度在1到32个字符'},
        ],
        passWord: [
          {required: true, message: '密码不能为空', trigger: 'blur'},
          {min: 5, max: 32, message: '长度在5到32个字符'},
        ],
        roleUid: [
          {required: true, message: '角色不能为空', trigger: 'blur'},
        ],
        projectUid: [
          {required: true, message: '项目不能为空', trigger: 'blur'},
        ]
      },
      editPasswordRules: {
        passWord: [
          {required: true, message: '密码不能为空', trigger: 'blur'},
          {min: 5, max: 32, message: '长度在5到32个字符'},
        ],
      }
    };
  },
  components: {
    AvatarCropper
  },
  created() {
    this.getDictList();
    this.adminList();
    this.roleList();
    this.projectList();
  },
  methods: {
    adminList: function() {
      var params = {}
      params.keyword = this.keyword
      params.projectUid = this.projectUid
      params.roleUid = this.roleUid
      params.currentPage = this.currentPage
      params.pageSize = this.pageSize
      getAdminList(params).then(response => {
        if(response.code == this.$ECode.SUCCESS) {
          /*let tableData = response.data.records;
          for(let a=0; a< tableData.length; a++) {
            tableData[a].maxStorageSize = tableData[a].maxStorageSize / 1024 / 1024

          }*/
          this.tableData = response.data.records;
          this.currentPage = response.data.current;
          this.pageSize = response.data.size;
          this.total = response.data.total;
        }
      });
    },
    /**
     * 字典查询
     */
    getDictList: function () {
      var params = {};
      params.dictType = 'sys_user_sex';
      getListByDictType(params).then(response => {
        if (response.code == this.$ECode.SUCCESS) {
          this.genderDictList = response.data.list;
          // 设置默认值
          if(response.data.defaultValue) {
            this.genderDefaultValue =response.data.defaultValue
          }
        }
      });
    },
    //角色远程搜索函数
    roleList: function () {
      var params = {};
      params.currentPage = 1;
      params.pageSize = 10;
      getRoleList(params).then(response => {
        this.roleOptions = response.data.records;
      });

    },

    //项目远程搜索函数
    projectList: function () {
      var params = {};
      params.currentPage = 1;
      params.pageSize = 1000;
      getProjectList(params).then(response => {
        this.projectOptions = response.data.records;
      });

    },

    handleClose(){
      this.dialogFormVisible = false;
      this.$refs.form.clearValidate();
    },

    cropSuccess(resData) {
      this.imagecropperShow = false
      this.imagecropperKey = this.imagecropperKey + 1
      let photoList = []
      photoList.push(resData[0].url);
      this.form.photoList = photoList;
      this.form.avatar = resData[0].uid
    },
    close() {
      this.imagecropperShow = false
    },
    deletePhoto: function() {
      this.form.photoList = null;
      this.form.ava = "";
      this.icon = false;
    },
    checkPhoto() {
      this.photoList = [];
      this.avatar = "";
      this.imagecropperShow = true;
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        gender: this.genderDefaultValue
      };
      return formObject;
    },
    handleFind: function() {
      this.adminList();
    },
    handleAdd: function() {
      this.title = "增加用户"
      this.dialogFormVisible = true;
      this.form = this.getFormObject();
      this.form.status = 0;
      this.isEditForm = false;
    },
    handleEdit: function(row) {
      this.title = "编辑用户";
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.form = row;
      this.roleValue = [];
      var roleList = [];
      //设置选择的角色列表
      if(row.roleList) {
        row.roleList.forEach(element => {
          roleList.push(element.uid);
        });
        this.roleValue = roleList;
      }
    },
    handlePassWordEdit: function() {
      this.passwordVisible = true;
      this.passwordForm.uid = this.form.uid;
      console.log("修改密码uid=",this.passwordForm.uid)
    },
    handRest: function(row) {
      var that = this;
      this.$confirm("此操作将会将该用户密码重置为默认密码, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          let params = {}
          params.uid = row.uid
          restPwdAdmin(params).then(response => {
            if (response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
            } else {
              this.$commonUtil.message.error(response.message)
            }
          });
        })
        .catch(() => {
          this.$commonUtil.message.info("已取消删除")
        });
    },
    //  计算文件大小
    calculateFileSize(size) {
      const B = 1024
      const KB = Math.pow(1024, 2)
      const MB = Math.pow(1024, 3)
      const GB = Math.pow(1024, 4)
      if (!size) {
        return '_'
      } else if (size < KB) {
        return (size / B).toFixed(0) + 'KB'
      } else if (size < MB) {
        return (size / KB).toFixed(1) + 'MB'
      } else if (size < GB) {
        return (size / MB).toFixed(2) + 'GB'
      } else {
        return (size / GB).toFixed(3) + 'TB'
      }
    },
    handleDelete: function(row) {
      this.$confirm("此操作将该管理员删除, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          let params = new URLSearchParams();
          var adminUids = [];
          adminUids.push(row.uid);
          params.append("adminUids", adminUids);
          deleteAdmin(params).then(response => {
            if(response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
            } else {
              this.$commonUtil.message.error(response.message)
            }
            this.adminList();
          });
        })
        .catch(() => {
          this.$commonUtil.message.info("已取消删除")
        });
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.adminList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.adminList();
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log("校验出错")
        } else {
          // console.log("请求参数="+JSON.stringify(this.form))
          if (this.isEditForm) {
            editAdmin(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.adminList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          } else {
            addAdmin(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.adminList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          }
        }
      })
    },
    submitEditPassword: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log("校验出错")
        } else {
          console.log("修改密码参数="+JSON.stringify(this.passwordForm))
          restPwdAdmin(this.passwordForm).then(response => {
            if (response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
              this.passwordVisible = false;
              this.passwordForm.passWord = null;
              this.adminList();
            } else {
              this.$commonUtil.message.error(response.message)
            }
          });
        }
      })
    }

  }
};
</script>

<style scoped>
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  margin: 0, 0, 0, 10px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 100px;
  height: 100px;
  line-height: 100px;
  text-align: center;
}
.imgBody {
  width: 100px;
  height: 100px;
  border: solid 2px #ffffff;
  float: left;
  position: relative;
}
.uploadImgBody {
  margin-left: 5px;
  width: 100px;
  height: 100px;
  border: dashed 1px #c0c0c0;
  float: left;
  position: relative;
}
.uploadImgBody :hover {
  border: dashed 1px #00ccff;
}
.inputClass {
  position: absolute;
}
img {
  width: 100px;
  height: 100px;
}
.dailog_view {
  height: 380px;
  overflow: auto;
}
.avatar-uploader{
  width: 280px;
}
.pwd-btn {
  background-color: salmon;
}
</style>
